unit Needs;

interface

uses Classes;

type
 TMethod = (tmNormal, tmL1T, tmL1Te, tmL1TL1T, tmC2S1eSne, tmHat, tmBkp, tmP2P, tmNone);
 DWord = LongWord;
 PByte = ^Byte;
 PWord = ^Word;
 PDWord = ^DWord;
 PBytes = ^TBytes;
 TBytes = Array[Word] of Byte;
 PWords = ^TWords;
 TWords = Array[Word] of Word;
 PDWords = ^TDWords;
 TDWords = Array[Word] of DWord;
 TItemState = (isCode, isBreak, isTerminate);
 PTableItem = ^TTableItem;
 {    }
 TTableItem = record
  tiCodes: String; //   
  tiString: WideString; //  
  tiState: TItemState;  //   ,    
  Next: PTableItem;    //  
 end;
 PTextString = ^TTextString;
 {  }
 TTextString = record
  Str: String;
  Next: PTextString;
 end;
 PTextStrings = ^TTextStrings;
 {       }
 TTextStrings = object
  Root, Cur: PTextString; //Root -  , Cur-  
  Count: Integer; //   
  constructor Init; // 
  function Add: PTextString; //  
  function Get(I: Integer): PTextString; //    
  destructor Done; // 
 end;
 PString = ^TString;
 {         }
 TString = Record
  stOriginal: String; // 
  stNew: WideString; //     
  Next: PString;    //  
 end;
 PStrings = ^TStrings;
 {    PTextStrings    PString}
 TStrings = Object
  Root, Cur: PString;
  Count: Integer;
  Constructor Init;
  Function Add: PString;
  Function Get(I: Integer): PString;
  Destructor Done;
 end;

 PDynamic = ^TDynamic;
 { ,   }
 TDynamic = Record
  Data: Pointer;
  Next: PDynamic;
 end;

 PTable = ^TTable;
 {    }
 TTable = Object
  Owner: PDynamic; //
  tbName: String;  // 
  Root, Cur: PTableItem; //root - , Cur -   
  EndRoot, EndCur: PTableItem; // 
  ElRoot, ElCur: PTableItem;  // 
  CMaxCodes, EndMaxCodes, ElMaxCodes: Integer; //     -
  CMaxChars: Integer; // -   - 
  Count, EndCount, ElCount: Integer; //  
  Constructor Init; // 
  Destructor Done;   //
  Function StringToData(S: WideString; CRLF: Boolean): String; //   HEX
  Function GetCodes(Var Data; Len: Integer): PTableItem;  //   
  Procedure ClearMain; //
  Procedure RefreshMax; // 
 end;

 TTextFileStream = class(TFileStream)
 {   .   ,  }
  public
    function Eof: Boolean;
    function ReadLn: string;
    procedure WriteString(const s: string);
    procedure WriteLn(const s: string); overload;
    procedure WriteLn; overload;
  end;

 PPointer = ^TPointer;
 {      ,     }
 TPointer = Record
  pnPos: Integer; // ,   
  pnPtr: Integer; //     ,  
  pnPtrOrig:Integer; //       , ..   

  pnTable1: PTable; //  
  pnTable2: PTable; // 
  pnReference: Integer; //
  pnFixed: Boolean; //       

  pnParamData: String; //
  pnStrings: PStrings; //    ,   
  Next: PPointer; // 
 end;

 PPointers = ^TPointers;
 {  PPointer}
 TPointers = Object
  Root, Cur: PPointer;
  Count: Integer;
 end;

 PDynamics = ^TDynamics;
 {   }
 TDynamics = Object
  DataSize: Integer;
  Root, Cur: PDynamic;
  Count: Integer;
 end;

 PParameters = ^TParameters;
 {  ,   }
 TParameters = Object(TDynamics)
  Before: Integer;
  AfterFix: Integer;
  BeforeFix: Integer;
 end;

 PPointerTable = ^TPointerTable;
 {    ,     }
 TPointerTable = Object
  Owner: PDynamic;
  ptName: WideString;
  ptTable1: PTable;
  ptTable2: PTable;
  ptDictionary: Pointer;
  ptStringLength: Integer;
  ptReference: Integer;
  ptPointerSize: Integer;
  ptMultiple: Integer;
  ptAlign: Integer;
  ptInterval: Integer;
  ptShiftLeft: Integer;
  ptMotorola: Boolean;
  ptSigned: Boolean;
  ptPunType: Boolean;
  ptPtrToPtr: Boolean;
  ptAutoStart: Boolean;
  ptSeekSame: Boolean;
  ptParameters: PParameters;
  ptPointers: PPointers;
  ptItemIndex: Integer;
    procedure SetPointer(ROM: PBytes; X, pnPos, pnPtr, pnReference: Integer);
    procedure SetPointerPun(ROM: PBytes; X, pnPos, pnPtr, pnReference: Integer);
  end;

 TAbcd = Packed Record A, B, C, D: Byte end;

Const
 KP_CRLF_CONVERT  = 1;
 LineEnd = #13#10;

{     Needs.pas}
Function StringsToTextStrings(Table: Pointer; Strings: Pointer; kpflags:integer): PTextStrings;  //  
function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; // 
Function HexVal(s: string): DWord; //  HEX,  
procedure DisposeStrings(TextStrings: PTextStrings); stdcall;// 
function GetEnd(Data: Pointer; Root: PTableItem; Max: Integer): PTableItem;// 
{         }
var
HexError: Boolean = False;

implementation

procedure DisposeStrings(TextStrings: PTextStrings); stdcall;
begin
 Dispose(TextStrings, Done);
end;

function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
asm
        PUSH    ESI
        PUSH    EDI
        MOV     ESI,P1
        MOV     EDI,P2
        MOV     EDX,ECX
        XOR     EAX,EAX
        AND     EDX,3
        SHR     ECX,1
        SHR     ECX,1
        REPE    CMPSD
        JNE     @@2
        MOV     ECX,EDX
        REPE    CMPSB
        JNE     @@2
        INC     EAX
@@2:    POP     EDI
        POP     ESI
end;

function TTextStrings.Get(I: Integer): PTextString;
var
 N: PTextString;
 J: Integer;
begin
 N := Root;
 J := 0;
 while N <> NIL do
 begin
  If J = I then
  begin
   Result := N;
   Exit;
  end;
  Inc(J);
  N := N^.Next;
 end;
 Result := NIL;
end;

constructor TTextStrings.Init;
begin
 Root := NIL;
 Cur := NIL;
 Count := 0;
end;

function TTextStrings.Add: PTextString;
begin
 New(Result);
 If Root = NIL then Root := Result Else Cur^.Next := Result;
 Cur := Result;
 Inc(Count);
 Result^.Str := '';
 Result^.Next := NIL;
end;

destructor TTextStrings.Done;
var
 N: PTextString;
begin
 while Root <> NIL do
 begin
  N := Root^.Next;
  Root^.Str := '';
  Dispose(Root);
  Root := N;
 end;
 Count := 0;
 Cur := NIL;
end;

Function TStrings.Get(I: Integer): PString;
Var N: PString; J: Integer;
begin
 N := Root;
 J := 0;
 While N <> NIL do
 begin
  If J = I then
  begin
   Result := N;
   Exit;
  end;
  Inc(J);
  N := N^.Next;
 end;
 Result := NIL;
end;

Constructor TStrings.Init;
begin
 Root := NIL;
 Cur := NIL;
 Count := 0;
end;

Function TStrings.Add: PString;
begin
 New(Result);
 If Root = NIL then Root := Result Else Cur^.Next := Result;
 Cur := Result;
 Inc(Count);
 Result^.stOriginal := '';
 Result^.stNew := '';
 Result^.Next := NIL;
end;

Destructor TStrings.Done;
Var N: PString;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Root^.stOriginal := '';
  Root^.stNew := '';
  Dispose(Root);
  Root := N;
 end;
 Count := 0;
 Cur := NIL;
end;


Function TTable.GetCodes(Var Data; Len: Integer): PTableItem;
Var N: PTableItem; J: Integer;
Label Good;
begin
 Result := NIL; N := NIL;
 If Len = 0 then Exit;
 J := CMaxChars;
 If J > Len then J := Len;
 While J > 0 do
 begin
  N := Root;
  While N <> NIL do With N^ do
  begin
   If Length(tiString) = J then
   begin
    If CompareMem(Addr(Data), Addr(tiString[1]), J shl 1) then
    Goto Good;
   end;
   N := Next;
  end;
  Dec(J);
 end;
 Exit;
 Good:
 Result := N;
end;

Function TTable.StringToData(S: WideString; CRLF: Boolean): String;
Var
 B: ^Word; T: PTableItem; J, Len: Integer; SlashMode: Boolean;
 Chain: String; Item: PTableItem;
begin
 B := Pointer(S); Result := '';
 Len := Length(S) shl 1;
 Chain := '';
 While Len > 0 do
 begin
  If B^ = 13 then
  begin
   Inc(B);
   Dec(Len, 2);
  end Else If B^ = 10 then
  begin
   If CRLF then if ElRoot <> NIL then
   begin
    SlashMode := False;
    Item := ElRoot;
    while Item <> NIL do with Item^ do
    begin
     J := Length(Chain) - Length(tiCodes);
     if (J >= 0) and
        CompareMem(Pointer(tiCodes), Addr(Chain[J + 1]), Length(tiCodes)) then
     begin
      SlashMode := True;
      Break;
     end;
     Item := Next;
    end;
    If not SlashMode then
     Result := Result + ElRoot.tiCodes;
   end;
   Inc(B);
   Dec(Len, 2);
   Chain := '';
  end Else
  begin
   If (WideChar(B^) = '/') and (Len > 2) then
   begin
    J := HexVal(Char(PWords(B)^[1]) + Char(PWords(B)^[2]));
    If not HexError then
    begin
     Chain := Chain + Char(J);
     Result := Result + Char(J);
     Inc(B, 3);
     Dec(Len, 6);
    end Else
    begin
     Inc(B);
     Dec(Len, 2);
    end;
   end Else
   begin
    Chain := '';
    T := GetCodes(B^, Len shr 1);
    If T <> NIL then With T^ do
    begin
     If tiState = isCode then Result := Result + tiCodes;
     J := Length(tiString) shl 1;
     Inc(Integer(B), J);
     Dec(Len, J);
    end Else
    begin
     Inc(B);
     Dec(Len, 2);
    end;
   end;
  end;
 end;
end;

Destructor TTable.Done;
Var N: PTableItem;
begin
 tbName := '';
 ClearMain;
 While EndRoot <> NIL do
 begin
  N := EndRoot^.Next;
  With EndRoot^ do
  begin
   tiCodes := '';
   tiString := '';
  end;
  Dispose(EndRoot);
  EndRoot := N;
 end;
 EndCount := 0;
 EndCur := NIL;
 While ElRoot <> NIL do
 begin
  N := ElRoot^.Next;
  With ElRoot^ do
  begin
   tiCodes := '';
   tiString := '';
  end;
  Dispose(ElRoot);
  ElRoot := N;
 end;
 ElCount := 0;
 ElCur := NIL;
end;

Constructor TTable.Init;
begin
 tbName := '';
 Root := NIL;
 Cur := NIL;
 EndRoot := NIL;
 EndCur := NIL;
 ElRoot := NIL;
 ElCur := NIL;
 Count := 0;
 EndCount := 0;
 ElCount := 0;
 RefreshMax;
end;

Procedure TTable.ClearMain;
Var N: PTableItem;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  With Root^ do
  begin
   tiCodes := '';
   tiString := '';
  end;
  Dispose(Root);
  Root := N;
 end;
 Count := 0;
 Cur := NIL;
end;

Procedure TTable.RefreshMax;
Var R: PTableItem;
begin
 R := Root; CMaxCodes := 0; CMaxChars := 0;
 While R <> NIL do With R^ do
 begin
  If CMaxCodes < Length(tiCodes) then
   CMaxCodes := Length(tiCodes);
  If CMaxChars < Length(tiString) then
   CMaxChars := Length(tiString);
  R := Next;
 end;
 R := EndRoot; EndMaxCodes := 0;
 While R <> NIL do With R^ do
 begin
  If EndMaxCodes < Length(tiCodes) then
   EndMaxCodes := Length(tiCodes);
  R := Next;
 end;
 R := ElRoot; ElMaxCodes := 0;
 While R <> NIL do With R^ do
 begin
  If ElMaxCodes < Length(tiCodes) then
   ElMaxCodes := Length(tiCodes);
  R := Next;
 end;
end;

Function HexVal(s: string): DWord;
Function sign(h: Char): Byte;
begin
 if h in ['0'..'9'] then Result := Byte(h) - 48 Else
 if h in ['A'..'F'] then Result := Byte(h) - 55 Else
                         Result := Byte(h) - 87;
end;
Const hs: Array[1..8] of DWord = ($1,
                                  $10,
                                  $100,
                                  $1000,
                                  $10000,
                                  $100000,
                                  $1000000,
                                  $10000000);
Var i: Byte; Label Error;
begin
 hexerror := true;
 Result := 0;
 If Length(s) <= 8 then
 begin
  For i := 1 to Length(s) do If not (s[i] in ['0'..'9', 'A'..'F', 'a'..'f']) then

Goto Error;
  Result := 0;
  for i := 1 to Length(s) do Inc(Result, sign(s[i]) * hs[length(s) + 1 - i]);
  hexerror := false;
 end Else
 begin Error:
  hexerror := true;
 end;
end;


function GetEnd(Data: Pointer; Root: PTableItem; Max: Integer): PTableItem;
var
 EF: Boolean;
 J: Integer;
begin
 EF := False;
 J := Max;
 repeat
  Result := Root;
  while Result <> NIL do With Result^ do
  begin
   If (Length(tiCodes) = J) and CompareMem(Data, Addr(tiCodes[1]), J) then
   begin
    EF := True;
    Break;
   end;
   Result := Next;
  end;
  Dec(J);
 until EF or (J = 0);
end;


function TTextFileStream.Eof: Boolean;
begin
  result := (Position >= Size);
end;

function TTextFileStream.ReadLn: string;
const
  BlkSize = 128;
var
  c: char;
  i: Integer;
begin
  SetLength(Result, BlkSize);
  i := 0;
  while not Eof do begin
    Read(c, SizeOf(c));
    if c = #13 then begin
      Read(c, SizeOf(c));
      if c <> #10 then begin
        Seek(SizeOf(c), soFromCurrent);
      end;
      break;
    end;
    {if c = #10 then begin
      break;
    end;}
    Inc(i);
    if i > BlkSize then
      SetLength(Result, Length(Result) + BlkSize);
    Result[i] := c;
  end;
  SetLength(Result, i);
end;

procedure TTextFileStream.WriteString(const s: string);
var
  i: integer;
begin
  for i := 1 to Length(s) do begin
    Write(s[i], SizeOf(s[i]));
  end;
end;

procedure TTextFileStream.WriteLn;
begin
  Write(LineEnd, Length(LineEnd));
end;

procedure TTextFileStream.WriteLn(const s: string);
begin
  WriteString(s);
  WriteLn;
end;

Function WordMotorola(X: DWord): Integer;
asm
 xchg   al,ah
 movzx  eax,ax
{ With TAbcd(Result) do
 begin
  A := TAbcd(X).B;
  B := TAbcd(X).A;
  C := 0;
  D := 0;
 end;}
end;

Function TripleMotorola(X: DWord): Integer;
begin
 With TAbcd(Result) do
 begin
  A := TAbcd(X).C;
  B := TAbcd(X).B;
  C := TAbcd(X).A;
  D := 0;
 end;
end;

Function DWordMotorola(X: DWord): Integer;
Asm
 bswap eax
end;


procedure TPointerTable.SetPointerPun(ROM: PBytes; X, pnPos, pnPtr, pnReference: Integer);
Var I: Integer; B: ^Byte;
begin
 Dec(pnPtr, pnReference);
 If (ptShiftLeft < 0) or (ptShiftLeft > 31) then ptShiftLeft := 0;
 pnPtr := pnPtr shr ptShiftLeft;
 If ptMotorola then Case ptPointerSize of
  2: pnPtr := WordMotorola(pnPtr);
  3: pnPtr := TripleMotorola(pnPtr);
  4: pnPtr := DWordMotorola(pnPtr);
 end;
 B := Addr(pnPtr);
 For I := 0 to ptPointerSize - 1 do
 begin
  ROM^[pnPos + I * X] := B^;
  Inc(DWord(B));
 end;
end;

procedure TPointerTable.SetPointer(ROM: PBytes; X, pnPos, pnPtr, pnReference: Integer);
begin
 Dec(pnPtr, pnReference);
 If ptSigned then
 begin
  Dec(pnPtr, X);
  If ptPointerSize = 2 then
   Integer(pnPtr) := SmallInt(pnPtr) Else
  If ptPointerSize = 1 then
   Integer(pnPtr) := ShortInt(pnPtr);
 end;
 If (ptShiftLeft < 0) or (ptShiftLeft > 31) then ptShiftLeft := 0;
 pnPtr := pnPtr shr ptShiftLeft;
 If ptMotorola then Case ptPointerSize of
  2: pnPtr := WordMotorola(pnPtr);
  3: pnPtr := TripleMotorola(pnPtr);
  4: pnPtr := DWordMotorola(pnPtr);
 end;
 Move(pnPtr, ROM^[pnPos], ptPointerSize);
end;

Function StringsToTextStrings(Table: Pointer; Strings: Pointer; kpflags:integer): PTextStrings;
 Var
  SS: PString;
  TBL: PTable absolute Table;
  STR: PStrings absolute Strings;
  begin
    Result := NIL;
    If Strings = NIL then Exit;
    New(Result, Init);
    With Result^ do
      begin
       SS := STR^.Root;
       While SS <> NIL do With SS^ do
        begin
          Add^.Str := TBL^.StringToData(stNew, KPFlags and KP_CRLF_CONVERT <> 0);
          SS := Next;
        end;
      end;
  end;


end.
